;// System  : DPMXCP - DPMI Exception Handler Library 1.01
;// File    : H_CHKSTK.ASM
;// Author  : Eric Woodruff,  CIS ID: 72134,1150
;// Updated : Mon 06/12/95 21:26:26
;// Note    : Copyright 1995, Eric Woodruff, All rights reserved
;// Compiler: Borland 4.xx
;//
;// 16-bit only.
;//
;// Calls to these routines are generated by the compiler to allocate stack
;// space in debug code regardless of the -k and -N settings.  The problem
;// with this is that the default routine has a large hard coded margin
;// value and it checks for a stack top value 10 bytes into the stack
;// segment which the exception handler's stack does not contain.  This can
;// generate a false stack overflow message and unnecessary program
;// termination.  This replacement ignores the margin value and simply
;// subtracts the requested amount from SP allowing the exception handler to
;// trap stack overflows via fault 0x0C.
;//
;// NOTE: Be sure to link the DPMXCP library in ahead of the standard
;//       libraries so that this routine is used!
;//

    MODEL LARGE

    CODESEG

;
; F_CHKSTK@ - Allocates local space.
;
; ax      number of bytes for local space

    public  N_CHKSTK@
    public  F_CHKSTK@
    public  __aNchkstk
    public  __aFchkstk

__aNchkstk:
N_CHKSTK@:

    pop     bx      ; For near calls, set up a far return address.
    push    cs      ; Probably not used, but retained for compatibility.
    push    bx

__aFchkstk:
F_CHKSTK@:

    pop     bx      ; Get the far return address.
    pop     dx

    sub     sp, ax  ; Adjust the stack.

    ; If the above SUB causes an overflow, the PUSH DX below will cause
    ; a stack fault (0x0C).  To find out what function caused it if you
    ; are in the debugger, exit via the old handler to end up here.
    ; Hit Ctrl+F4 (Evaluate/Modify), type SP to get the stack pointer,
    ; go into the New Value input area, type SP+AX, and hit ENTER.
    ; This will reset the stack pointer to a good position.  Hit escape
    ; and single step (F7) through the return to find out where this was
    ; called from.

    push    dx      ; Push the return address and exit.
    push    bx
    retf

    END
